require "mailMapper/version"

module MailMapper
require 'json' 

def self.find(path=" ", option = 0)
	text=File.open(path).read
    	if option == 0
   		  mails = mapMails(text)	
   		  return reduceMails(mails)
		elsif option == 1
		  mails = mapMails(text)	
		  return mails.each_with_object(Hash.new(0)) { |mail,counts| counts[mail] += 1 }	
    	elsif option == 2
		  mails = mapMails(text)
    	  return mapMails(text)
		end	
end

def self.mapMails(text)
	mails = []
	#Map text
	line_num=0
	text.gsub!(/\r\n?/, "\n")
	text.each_line do |line|
	mails << line[/[a-zA-Z_]+?@[a-zA-Z_]+?\.[a-zA-Z]{2,3}.[a-zA-Z]{2,3}|[a-zA-Z_]+?@[a-zA-Z_]+?\.[a-zA-Z]{2,3}/]end
	mails.compact!
	# BEGIN map email function
	return mails
end

def self.reduceMails(mails=@mails)
    mailExt = []
	mapHash = {}
	domain = ""
	mails.each {|x|
	# Set domain extension (after "@")	
	domain = x[/@[a-zA-Z_]+?\.[a-zA-Z]{2,3}.[a-zA-Z]{2,3}|@[a-zA-Z_]+?\.[a-zA-Z]{2,3}/]
	search = mapHash.select{|key, value| key[domain]}
	    if search.empty?
	    	@r = mapHash.merge!({ domain => 1})
	    else
	        mapHash[domain] += 1 
	    end	
	}
	return @r
end
end
